shutdown: doesn't handle error from sysv_change_runlevel

Bug #426332 reported by Mario Limonciello on 2009-09-08
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
upstart
Low
Scott James Remnant (Canonical)
0.6
Low
Scott James Remnant (Canonical)
Trunk
Undecided
Unassigned
upstart (Ubuntu)
Low
Unassigned

Bug Description

This was a bug found in https://bugs.edge.launchpad.net/ubuntu/+source/ubiquity/+bug/412825 originally. When an error is thrown from sysv_change_runlevel, it's not properly handled:

Sep 2 15:02:43 ubuntu ubiquity: shutdown: Did not receive a reply. Possible causes include: the remote application did not send a reply, the message bus security policy blocked the reply, the reply timeout expired, or the network connection was broken.
Sep 2 15:02:43 ubuntu ubiquity: shutdown:sysv.c:181: Unhandled error from sysv_change_runlevel: Did not receive a reply. Possible causes include: the remote application did not send a reply, the message bus security policy blocked the reply, the reply timeout expired, or the network connection was broken.
Sep 2 15:02:43 ubuntu ubiquity[16945]: log-output -t ubiquity reboot

Changed in upstart:
importance: Undecided → Low
status: New → Triaged
Changed in upstart:
status: Triaged → Fix Committed
assignee: nobody → Scott James Remnant (scott)
milestone: none → 0.7.0

(sorry about the status spam, was trying to get LP to DTRT with the statuses, but I failed)

Changed in upstart:
status: Invalid → Fix Committed
milestone: 0.7.0 → none
Changed in upstart (Ubuntu):
status: New → Triaged
importance: Undecided → Low
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package upstart - 0.6.3-8

---------------
upstart (0.6.3-8) karmic; urgency=low

  * Rather than calling "telinit u" after upgrade, which will lose state,
    have the umountroot initscript take care of it for us by setting a
    flag. LP: #441796.
  * Don't lose the original default runlevel if /etc/inittab exists without
    an initdefault line. LP: #405847.
  * Fix "unhandled error" in shutdown when unable to change runlevel,
    e.g. due to previous Ubiquity bug. LP: #426332.
  * Merge change from trunk that makes it possible to build Upstart using
    a previously built copy of nih-dbus-tool, especially useful when
    cross-compiling. LP: #426740.
  * Merge change from libnih to store our assertion messages in the
    glibc __abort_msg symbol so apport can pick them up. LP: #429411.
  * Merge change from libnih to fix compilation issue with eglibc due
    to changed alphasort() prototype.

 -- Scott James Remnant <email address hidden> Wed, 14 Oct 2009 05:34:13 +0100

Changed in upstart (Ubuntu):
status: Triaged → Fix Released
Changed in upstart:
milestone: none → 0.6.5

0.6.5 2010-02-04 "Our last, best hope for victory"

 * Since libnih has been separated out into its own project, Upstart
   no longer includes its source and now uses the installed version by
   default.

 * The external nih-dbus-tool means that cross-compilation is trivial,
   the path to it may be overriden with NIH_DBUS_TOOL=... as an
   argument to configure. (Bug: #426740)

 * Developers may still build against a local libnih source tree by
   passing --with-local-libnih=/path/to/libnih to configure.

 * There is a new initctl "reload" command, with matching
   /sbin/reload symlink. This sends the SIGHUP signal to the running
   main process of the named job instance.

 * Event operator matches in jobs now support "!=" in addition to the
   usual "=", e.g.:

  start on net-device-added INTERFACE!=eth*

   (Bug: #513035)

 * Moved D-Bus system bus reconnection trigger from SIGHUP to SIGUSR1,
   since SIGHUP is already used for a forced configuration reload and
   causes Upstart to "forget" state.

 * Fixed bug where the default runlevel would be lost when an
   /etc/inittab file exists without an initdefault line. (Bug: #405847)

 * Fixed "Unhandled error" message from shutdown. (Bug: #426332)

 * Fixed "Unhandled error" assertion crash from Upstart child
   processes when failing to spawn a job. (Bug: #451917)

 * No longer holds /dev/console open, so the SAK SysRq key will not
   kill Upstart. (Bug: #486005)

 * Restored sync() call before reboot().

 * Added missing OPTIONS section to init(8) manpage. (Bug: #449883)

Changed in upstart:
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers